

{

Generate 'Em!
by Antti Kirjavainen

A simple password generator for Linux/Windows.

Sorry about the messy code, it was converted from VB
with a conversion program.

You may use any parts of this code you like.

}


unit Main;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls {$IFDEF LINUX}, QClipbrd{$ENDIF} {$IFDEF MSWINDOWS}, Clipbrd{$ENDIF};

const
   AllowedDefault = 'ABCDEFGHIJKLMNOPQRSTUVXYZ1234567890';

type
  TfrmMain = class(TForm)
    cmdOK: TButton;
    fraAllowed: TGroupBox;
    lblLength: TLabel;
    txtLength: TEdit;
    chkUppercase: TCheckBox;
    chkLowercase: TCheckBox;
    txtChars: TEdit;
    optThis: TRadioButton;
    optAny: TRadioButton;
    fraPassword: TGroupBox;
    txtPassword: TEdit;
    procedure cmdOKClick(Sender: TObject);
    procedure txtLengthKeyPress(Sender: TObject; var Key: Char);
    procedure txtPasswordKeyPress(Sender: TObject; var Key: Char);
    procedure optAnyClick(Sender: TObject);
    procedure optThisClick(Sender: TObject);
  procedure AppException(Sender: TObject; E: Exception);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  function CreateEncryptionKey(lnLength: longint; Allowed: string) : string;

implementation

{$R *.xfm}

function CreateEncryptionKey(lnLength: longint; Allowed: string) : string;
var
    c : Integer;
    CurKey : String;
    Used : String;
    lChar : String;
    i : Integer;

begin

     // Create a random encryption key to be used:
     // Create random ASCII-codes and add the letter to the key:
     // Try 1000 times to get a right number:

Allowed := LowerCase(Allowed);
i := 0;

repeat

                Randomize;
                c := Random(127);
                lChar := LowerCase(Char(c));
                
                if (Length(Allowed) = 0) then begin
                                       if (Pos(lChar, Used) = 0) then begin
                                                                        CurKey := CurKey + Char(c);
                                                                        Used := Used + lChar;
                                                                        end;
                                       end
                                       else begin
                                        if (Pos(lChar, Allowed) > 0) And (Pos(lChar, Used) = 0) then begin
                                                                                                        CurKey := CurKey + Char(c);
                                                                                                        Used := Used + lChar;
                                                                                                        end;
                                       end;

i := i + 1;
if (i > 10000000) then break;

until (Length(CurKey) >= lnLength);


   // The key is ready. Now, that wasn't so hard, was it =)
   CreateEncryptionKey := CurKey;
end;
 
 
function OnlyNumeric(const Key : Char) :Char;
begin
if (Ord(Key) = 8) then begin
                  OnlyNumeric := Key;
                  exit;
                  end;

if (Ord(Key) < 48) or (Ord(Key) > 57) then begin
                   OnlyNumeric := Char(0);
                   exit;
                   end
                   else begin
                   OnlyNumeric := Key;
                   end;
end;



procedure TfrmMain.cmdOKClick(Sender: TObject);
begin
cmdOK.enabled := False;
   if (Length(txtLength.text) = 0 ) then txtLength.text := '8';
   if (StrToInt(txtLength.Text) > 30) then txtLength.Text := '30';
   if (optThis.Checked) and (Length(txtChars.Text) < StrToInt(txtLength.Text)) then txtLength.Text := IntToStr(Length(txtChars.Text));
   if (Length(txtChars.text) = 0) then txtChars.text := AllowedDefault;
   if (chkLowercase.State = cbUnchecked) and (chkUppercase.State = cbUnchecked) then chkLowercase.State := cbChecked;
   if (optAny.Checked) then txtPassword.text := CreateEncryptionKey(StrToInt(txtLength.text) , '') else txtPassword.text := CreateEncryptionKey(StrToInt(txtLength.text), txtChars.text);

   if (chkLowerCase.State = cbChecked) and (chkUpperCase.State = cbUnchecked) then txtPassword.text := LowerCase(txtPassword.text);
   if (chkLowercase.State = cbUnchecked) and (chkUppercase.State = cbChecked) then txtPassword.text := UpperCase(txtPassword.text);
   cmdOK.Enabled := True;

   ClipBoard.AsText := txtPassword.Text;

end;

procedure TfrmMain.txtLengthKeyPress(Sender: TObject; var Key: Char);
begin
Key := OnlyNumeric(Key);
end;

procedure TfrmMain.txtPasswordKeyPress(Sender: TObject; var Key: Char);
begin
Key := Char(0);
end;

procedure TfrmMain.optAnyClick(Sender: TObject);
begin
      txtChars.enabled := False;
end;

procedure TfrmMain.optThisClick(Sender: TObject);
begin
      txtChars.enabled := True;
end;

procedure TfrmMain.AppException(Sender: TObject; E: Exception);
begin
// Nothing
end;


procedure TfrmMain.FormCreate(Sender: TObject);
begin
Application.OnException := AppException;
txtChars.Text := AllowedDefault;
end;

end.
